/**
 * Copyright (C) 2017, GINDUMAC GmbH
 *
 * bma280_gindumac.c
 * Date: 15/05/2017
 * Revision: 1.1
 *
 * Usage: BMA280 accelerometer sensor (SPI or TWI)
 */

/**
 * INCLUDES
 */
#include "bme280_gindumac.h"

#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "app_util_platform.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"

// GINDUMAC communication libraries
#include "spi_gindumac.h"
#include "twi_gindumac.h"

// LOGs
#define NRF_LOG_MODULE_NAME "BME280"

#include "nrf_log.h"
struct bme280_driver bme280;
bool model_plus = false;
/* Initialize the sensor
 * Inputs: none
 */
bool init_bme280_temperature(void) {

	uint8_t Id;

	spi_twi_read_register(BME280_ID_REGISTER , &Id, 1);
	if (Id != BME280_ID_REGISTER)
		NRF_LOG_INFO("Chip ID: %02x\r\n", Id);
		return false;


	return true;

	uint8_t reg;
	bme280.cp.dig_T1 = spi_twi_read_register(BME280REG_CALIB_00, &reg, 1);
	bme280.cp.dig_T1 |= spi_twi_read_register(BME280REG_CALIB_00 + 1, &reg, 1)
			<< 8;
	bme280.cp.dig_T2 = spi_twi_read_register(BME280REG_CALIB_00 + 2, &reg, 1);
	bme280.cp.dig_T2 |= spi_twi_read_register(BME280REG_CALIB_00 + 3, &reg, 1)
			<< 8;
	bme280.cp.dig_T3 = spi_twi_read_register(BME280REG_CALIB_00 + 4, &reg, 1);
	bme280.cp.dig_T3 |= spi_twi_read_register(BME280REG_CALIB_00 + 5, &reg, 1)
			<< 8;

	bme280.cp.dig_P1 = spi_twi_read_register(BME280REG_CALIB_00 + 6, &reg, 1);
	bme280.cp.dig_P1 |= spi_twi_read_register(BME280REG_CALIB_00 + 7, &reg, 1)
			<< 8;
	bme280.cp.dig_P2 = spi_twi_read_register(BME280REG_CALIB_00 + 8, &reg, 1);
	bme280.cp.dig_P2 |= spi_twi_read_register(BME280REG_CALIB_00 + 9, &reg, 1)
			<< 8;
	bme280.cp.dig_P3 = spi_twi_read_register(BME280REG_CALIB_00 + 10, &reg, 1);
	bme280.cp.dig_P3 |= spi_twi_read_register(BME280REG_CALIB_00 + 11, &reg, 1)
			<< 8;
	bme280.cp.dig_P4 = spi_twi_read_register(BME280REG_CALIB_00 + 12, &reg, 1);
	bme280.cp.dig_P4 |= spi_twi_read_register(BME280REG_CALIB_00 + 13, &reg, 1)
			<< 8;
	bme280.cp.dig_P5 = spi_twi_read_register(BME280REG_CALIB_00 + 14, &reg, 1);
	bme280.cp.dig_P5 |= spi_twi_read_register(BME280REG_CALIB_00 + 15, &reg, 1)
			<< 8;
	bme280.cp.dig_P6 = spi_twi_read_register(BME280REG_CALIB_00 + 16, &reg, 1);
	bme280.cp.dig_P6 |= spi_twi_read_register(BME280REG_CALIB_00 + 17, &reg, 1)
			<< 8;
	bme280.cp.dig_P7 = spi_twi_read_register(BME280REG_CALIB_00 + 18, &reg, 1);
	bme280.cp.dig_P7 |= spi_twi_read_register(BME280REG_CALIB_00 + 19, &reg, 1)
			<< 8;
	bme280.cp.dig_P8 = spi_twi_read_register(BME280REG_CALIB_00 + 20, &reg, 1);
	bme280.cp.dig_P8 |= spi_twi_read_register(BME280REG_CALIB_00 + 21, &reg, 1)
			<< 8;
	bme280.cp.dig_P9 = spi_twi_read_register(BME280REG_CALIB_00 + 22, &reg, 1);
	bme280.cp.dig_P9 |= spi_twi_read_register(BME280REG_CALIB_00 + 23, &reg, 1)
			<< 8;
/*
	bme280.cp.dig_T1 = spi_twi_read_register(0x88, &reg[0], 1);
	bme280.cp.dig_T1 |= spi_twi_read_register(0x89, &reg[1], 1) << 8;

	bme280.cp.dig_T2 = spi_twi_read_register(0x8A, &reg[2], 1);
	bme280.cp.dig_T2 |= spi_twi_read_register(0x8B, &reg[3], 1) << 8;

	bme280.cp.dig_T3 = spi_twi_read_register(0x8C, &reg[4], 1);
	bme280.cp.dig_T3 |= spi_twi_read_register(0x8D, &reg[5], 1) << 8;

	bme280.cp.dig_P1 = spi_twi_read_register(0x8E, &reg[6], 1);
	bme280.cp.dig_P1 |= spi_twi_read_register(0x8F, &reg[7], 1) << 8;

	bme280.cp.dig_P2 = spi_twi_read_register(0x90, &reg[8], 1);
	bme280.cp.dig_P2 |= spi_twi_read_register(0x91, &reg[9], 1) << 8;

	bme280.cp.dig_P3 = spi_twi_read_register(0x92, &reg[10], 1);
	bme280.cp.dig_P3 |= spi_twi_read_register(0x93, &reg[11], 1) << 8;

	bme280.cp.dig_P4 = spi_twi_read_register(0x94, &reg[12], 1);
	bme280.cp.dig_P4 |= spi_twi_read_register(0x95, &reg[13], 1) << 8;

	bme280.cp.dig_P5 = spi_twi_read_register(0x96, &reg[14], 1);
	bme280.cp.dig_P5 |= spi_twi_read_register(0x97, &reg[15], 1) << 8;

	bme280.cp.dig_P6 = spi_twi_read_register(0x98, &reg[16], 1);
	bme280.cp.dig_P6 |= spi_twi_read_register(0x99, &reg[17], 1) << 8;

	bme280.cp.dig_P7 = spi_twi_read_register(0x9A, &reg[18], 1);
	bme280.cp.dig_P7 |= spi_twi_read_register(0x9B, &reg[19], 1) << 8;

	bme280.cp.dig_P8 = spi_twi_read_register(0x9C, &reg[20], 1);
	bme280.cp.dig_P8 |= spi_twi_read_register(0x9D, &reg[21], 1) << 8;

	bme280.cp.dig_P9 = spi_twi_read_register(0x9E, &reg[22], 1);
	bme280.cp.dig_P9 |= spi_twi_read_register(0x9F, &reg[23], 1) << 8;*/

	bme280.cp.dig_H1 = spi_twi_read_register(0xA1, &reg, 1);

	bme280.cp.dig_H2 = spi_twi_read_register(0xE1, &reg, 1);
	bme280.cp.dig_H2 |= spi_twi_read_register(0xE2, &reg, 1) << 8;

	bme280.cp.dig_H3 = spi_twi_read_register(0xE3, &reg, 1);

	bme280.cp.dig_H4 = spi_twi_read_register(0xE4, &reg, 1) << 4;		// 11:4
	bme280.cp.dig_H4 |= spi_twi_read_register(0xE5, &reg, 1) & 0x0f;	// 3:0

	bme280.cp.dig_H5 = spi_twi_read_register(0xE5, &reg, 1) >> 4;		// 3:0
	bme280.cp.dig_H5 |= spi_twi_read_register(0xE6, &reg, 1) << 4;		// 11:4

	bme280.cp.dig_H6 = spi_twi_read_register(0xE7, &reg, 1);

	spi_twi_write_register(BME280_ID_REGISTER , Id);

	return BME280_RET_OK;
}

BME280_Ret read_mode(void) {
	uint8_t conf, reg;

	spi_twi_read_register(BME280_CTRL_HUMIDITY, &reg, 1);

	spi_twi_read_register(BME280_CTRL_MEASURMENT, &conf, 1);
	NRF_LOG_INFO("CONFIG before mode: %02x\r\n", conf);
	spi_twi_write_register(BME280_CTRL_HUMIDITY, reg); //HUMIDITY must be written first
	conf = conf & 0xFC;
	conf |= BME280_MODE_NORMAL;
	bme280_read_measurements();
	//reg &= 0b00011111;
	//reg |= (os << 5);

	//    nrf_delay_ms(50);
	//	conf  &= 0x20;

	spi_twi_write_register(BME280_CTRL_MEASURMENT, conf);
	NRF_LOG_INFO("CONFIG after mode: %02x\r\n", conf);

	spi_twi_read_register(BME280_CONFIG_REGISTER, &conf, 1);

	spi_twi_write_register(BME280_CONFIG_REGISTER, conf);

	return BME280_RET_OK;
}

/*
 *  TODO: Adjust timer frequency by BME280 sampling speed.
 */
BME280_Ret bme280_set_interval(enum BME280_INTERVAL interval) {
	uint8_t conf;
	BME280_Ret status = BME280_RET_ERROR;

	spi_twi_read_register(BME280_CONFIG_REGISTER, &conf, 1);
	conf = conf & ~ BME280_INTERVAL_MASK;
	conf |= interval;
	status = spi_twi_write_register(BME280_CONFIG_REGISTER, conf);

	return status;
}

int bme280_is_measuring(void) {

	uint8_t s;

	s = spi_twi_read_register(BME280REG_STATUS, &s, 1);
	NRF_LOG_INFO("Status: %02x\r\n", s);
	if (s & 0b00001000) {
		return 1;
	} else {
		return 0;
	}
}

BME280_Ret bme280_set_oversampling_hum(uint8_t os) {

	uint8_t meas;
	meas = spi_twi_read_register(BME280_CTRL_MEASURMENT, &meas, 1);
	spi_twi_write_register(BME280_CTRL_HUMIDITY, os);
	return spi_twi_write_register(BME280_CTRL_MEASURMENT, meas); //Changes to humi take effect after write to meas
}

BME280_Ret bme280_set_oversampling_temp(uint8_t os) {
	uint8_t humi, meas;
	humi = spi_twi_read_register(BME280_CTRL_HUMIDITY, &humi, 1);
	meas = spi_twi_read_register(BME280_CTRL_MEASURMENT, &meas, 1);
	spi_twi_write_register(BME280_CTRL_HUMIDITY, humi);
	meas &= 0b00011111;
	meas |= (os << 5);
	return spi_twi_write_register(BME280_CTRL_MEASURMENT, meas);
}

BME280_Ret bme280_set_oversampling_press(uint8_t os) {
	uint8_t humi, meas;
	humi = spi_twi_read_register(BME280_CTRL_HUMIDITY, &humi, 1);
	meas = spi_twi_read_register(BME280_CTRL_MEASURMENT, &meas, 1);
	spi_twi_write_register(BME280_CTRL_HUMIDITY, humi);
	meas &= 0b11100011;
	meas |= (os << 2);
	return spi_twi_write_register(BME280_CTRL_MEASURMENT, meas);
}

/**
 * @brief Read new raw values.
 */
BME280_Ret bme280_read_measurements() {
	uint8_t data[8];

	/* TODO use burst read */

	spi_twi_read_register(0xF7, &data[0], 8);

	bme280.adc_h = data[7] + ((uint32_t) data[6] << 8);

	bme280.adc_t = (uint32_t) data[5] >> 4;
	bme280.adc_t |= (uint32_t) data[4] << 8;
	bme280.adc_t |= (uint32_t) data[3] << 12;

	bme280.adc_p = (uint32_t) data[2] >> 4;
	bme280.adc_p |= (uint32_t) data[1] << 8;
	bme280.adc_p |= (uint32_t) data[0] << 12;

	NRF_LOG_INFO(" msb_pres (hex): %08x\r\n", bme280.adc_p);
	//NRF_LOG_INFO(" lsb_pres (hex): %02x\r\n",bme280.adc_p);
	//NRF_LOG_INFO(" xlsb_pres (hex): %02x\r\n", xlsb_pres);
	NRF_LOG_INFO(" msb_temp (hex): %08x\r\n", bme280.adc_t);
	//NRF_LOG_INFO(" lsb_temp (hex): %02x\r\n", lsb_temp);
	//NRF_LOG_INFO(" xlsb_temp (hex): %02x\r\n", xlsb_temp);
	NRF_LOG_INFO(" msb_hum (hex): %08x\r\n", bme280.adc_h);
	//NRF_LOG_INFO(" lsb_hum (hex): %02x\r\n", lsb_hum);

	return BME280_RET_OK;
}

uint32_t compensate_P_int64(int32_t adc_P) {
	int64_t var1, var2, p;

	var1 = ((int64_t) bme280.t_fine) - 128000;
	var2 = var1 * var1 * (int64_t) bme280.cp.dig_P6;
	var2 = var2 + ((var1 * (int64_t) bme280.cp.dig_P5) << 17);
	var2 = var2 + (((int64_t) bme280.cp.dig_P4) << 35);
	var1 = ((var1 * var1 * (int64_t) bme280.cp.dig_P3) >> 8)
			+ ((var1 * (int64_t) bme280.cp.dig_P2) << 12);
	var1 = (((((int64_t) 1) << 47) + var1)) * ((int64_t) bme280.cp.dig_P1)
			>> 33;
	if (var1 == 0) {
		return 0;
	}

	p = 1048576 - adc_P;
	p = (((p << 31) - var2) * 3125) / var1;
	var1 = (((int64_t) bme280.cp.dig_P9) * (p >> 13) * (p >> 13)) >> 25;
	var2 = (((int64_t) bme280.cp.dig_P8) * p) >> 19;
	p = ((p + var1 + var2) >> 8) + (((int64_t) bme280.cp.dig_P7) << 4);

	return (uint32_t) p;
}

uint32_t compensate_H_int32(int32_t adc_H) {
	int32_t v_x1_u32r;

	v_x1_u32r = (bme280.t_fine - ((int32_t) 76800));
	v_x1_u32r = (((((adc_H << 14) - (((int32_t) bme280.cp.dig_H4) << 20)
			- (((int32_t) bme280.cp.dig_H5) * v_x1_u32r)) + ((int32_t) 16384))
			>> 15)
			* (((((((v_x1_u32r * ((int32_t) bme280.cp.dig_H6)) >> 10)
					* (((v_x1_u32r * ((int32_t) bme280.cp.dig_H3)) >> 11)
							+ ((int32_t) 32768))) >> 10) + ((int32_t) 2097152))
					* ((int32_t) bme280.cp.dig_H2) + 8192) >> 14));

	v_x1_u32r = (v_x1_u32r
			- (((((v_x1_u32r >> 15) * (v_x1_u32r >> 15)) >> 7)
					* ((int32_t) bme280.cp.dig_H1)) >> 4));
	v_x1_u32r = (v_x1_u32r < 0 ? 0 : v_x1_u32r);
	v_x1_u32r = (v_x1_u32r > 419430400 ? 419430400 : v_x1_u32r);

	return (uint32_t) (v_x1_u32r >> 12);
}

int32_t compensate_T_int32(int32_t adc_T) {
	int32_t var1, var2, T;

	var1 = ((((adc_T >> 3) - ((int32_t) bme280.cp.dig_T1 << 1)))
			* ((int32_t) bme280.cp.dig_T2)) >> 11;
	var2 = (((((adc_T >> 4) - ((int32_t) bme280.cp.dig_T1))
			* ((adc_T >> 4) - ((int32_t) bme280.cp.dig_T1))) >> 12)
			* ((int32_t) bme280.cp.dig_T3)) >> 14;

	bme280.t_fine = var1 + var2;

	T = (bme280.t_fine * 5 + 128) >> 8;

	return T/100;
}


/**
 * Returns temperature in DegC, resolution is 0.01 DegC.
 * Output value of  equals 21.34 DegC.
 */
int32_t bme280_get_temperature(void) {

	int32_t temp = compensate_T_int32(bme280.adc_t);
	//NRF_LOG_INFO(" Temperature (hex): %02x\r\n", bme280.adc_t);
	NRF_LOG_INFO(" Temperature: %d\r\n", (int) bme280.adc_t);

	return temp;
}

/**
 * Returns pressure in Pa as unsigned 32 bit integer in Q24.8 format
 * (24 integer bits and 8 fractional bits).
 * Output value of â€œ24674867â€� represents 24674867/256 = 96386.2 Pa = 963.862 hPa
 */
uint32_t bme280_get_pressure(void) {
	uint32_t press = compensate_P_int64(bme280.adc_p);
	//NRF_LOG_INFO(" Pressure (hex): %02x\r\n",bme280.adc_p);
NRF_LOG_INFO(" Pressure: %d\r\n", (int)bme280.adc_p);
	return press;
}

/**
 * Returns humidity in %RH as unsigned 32 bit integer in Q22.10 format
 * (22 integer and 10 fractional bits).
 * Output value of â€œ50532â€� represents 50532/1024 = 49.356 %RH
 */
uint32_t bme280_get_humidity(void) {
	uint32_t humi = compensate_H_int32(bme280.adc_h);
	//NRF_LOG_INFO(" Humidity(hex): %02x\r\n", bme280.adc_h);
	NRF_LOG_INFO(" Humidity: %d\r\n", (int) bme280.adc_h);
	return humi;
}

void timer_bme280_event_handler(void* p_context)
{
    //NRF_LOG_INFO("BME\r\n");
    bme280_read_measurements(); //read previous data
}

/*BME280_Ret read_temperature_data(void) {

 //uint8_t conf, reg, status;
 uint8_t msb_pres;		// MSB data
 uint8_t lsb_pres; 		// LSB data
 uint8_t xlsb_pres;

 uint8_t msb_temp;		// MSB data
 uint8_t lsb_temp; 		// LSB data
 uint8_t xlsb_temp;

 uint8_t msb_hum;		// MSB data
 uint8_t lsb_hum; 		// LSB data

 uint8_t os;
 uint8_t lmsb[8];	// MSB + LSB
 int32_t adc_T;
 long temp;
 long temp_comp; //Temperature data
 long press;
 long hum;
 float tempValue;	// Temperature value
 //   float pressValue;*/

//spi_twi_read_register(BME280_CTRL_HUMIDITY, &reg, 1);
/*	spi_twi_read_register(BME280_CTRL_MEASURMENT, &conf, 1);
 NRF_LOG_INFO("CONFIG before mode: %02x\r\n", conf);
 spi_twi_write_register(BME280_CTRL_HUMIDITY, reg); //HUMIDITY must be written first

 conf |= 0x77 & BME280_MODE_FORCED;

 reg &= 0b00011111;
 reg |= (os << 5);

 //    nrf_delay_ms(50);
 //	conf  &= 0x20;

 spi_twi_write_register(BME280_CTRL_MEASURMENT, conf);
 NRF_LOG_INFO("CONFIG after mode: %02x\r\n", conf);

 spi_twi_read_register(BME280_CONFIG_REGISTER, &conf, 1);

 spi_twi_write_register(BME280_CONFIG_REGISTER, conf);

 nrf_delay_ms(62.5);
 conf |= 0x01;
 spi_twi_read_register(BME280REG_STATUS, &status, 1);
 NRF_LOG_INFO("Status: %02x\r\n", status);

 spi_twi_read_register(BME280REG_STATUS, &status, 1);
 NRF_LOG_INFO("Status: %02x\r\n", status);*/

// Burst read data
/*spi_twi_read_register(0xF7, &lmsb[0], 8);

 msb_pres = lmsb[0];
 lsb_pres = lmsb[1];
 xlsb_pres = lmsb[2];

 msb_temp = lmsb[3];
 lsb_temp = lmsb[4];
 xlsb_temp = lmsb[5];

 msb_hum = lmsb[6];
 lsb_hum = lmsb[7];

 temp = (uint32_t) ((((uint32_t) ((uint8_t) msb_temp)) << 12)
 | (((uint32_t) ((uint8_t) lsb_temp)) << 4)
 | (((uint32_t) ((uint8_t) xlsb_temp)) >> 4));

 temp = temp >> 2;
 //temp = temp & 0x1FFF;

 press = (uint32_t) ((((uint32_t) ((uint8_t) msb_pres)) << 12)
 | (((uint32_t) ((uint8_t) lsb_pres)) << 4)
 | (((uint32_t) ((uint8_t) xlsb_pres)) >> 4));

 press = press >> 2;
 //press = press & 0x1FFF; // Remove sign bit

 hum = (uint32_t) ((((uint32_t) ((uint8_t) msb_hum)))
 | (((uint32_t) ((uint8_t) lsb_hum)<<8)));

 hum = hum >> 2;
 //hum = hum & 0x1FFF; // Remove sign bit

 // Print received data
 NRF_LOG_INFO(" msb_pres (hex): %02x\r\n", msb_pres);
 NRF_LOG_INFO(" lsb_pres (hex): %02x\r\n", lsb_pres);
 NRF_LOG_INFO(" xlsb_pres (hex): %02x\r\n", xlsb_pres);
 NRF_LOG_INFO(" msb_temp (hex): %02x\r\n", msb_temp);
 NRF_LOG_INFO(" lsb_temp (hex): %02x\r\n", lsb_temp);
 NRF_LOG_INFO(" xlsb_temp (hex): %02x\r\n", xlsb_temp);
 NRF_LOG_INFO(" msb_hum (hex): %02x\r\n", msb_hum);
 NRF_LOG_INFO(" lsb_hum (hex): %02x\r\n", lsb_hum);

 NRF_LOG_INFO(" temp (hex): %02x\r\n", temp);
 NRF_LOG_INFO(" temp (dec): %d\r\n", (int) temp);
 NRF_LOG_INFO(" sign: %01x\r\n", temp >> 7);

 NRF_LOG_INFO(" press (hex): %02x\r\n", press);
 NRF_LOG_INFO(" press (dec): %d\r\n", (int) press);
 NRF_LOG_INFO(" sign: %01x\r\n", temp >> 7);

 NRF_LOG_INFO(" humid (hex): %02x\r\n", hum);
 NRF_LOG_INFO(" humid (dec): %d\r\n", (int) hum);
 NRF_LOG_INFO(" sign: %01x\r\n", temp >> 7);

 // tempValue=temp/100;*/

/*	if (temp>> 7 == 0){
 // =0 positive
 temp = (bme280.t_fine * 5 + 128);
 tempValue= temp/100;

 } else {
 // =1 negative
 temp = bme280.t_fine & 0x7F; // Remove sign bit
 temp = (bme280.t_fine * 5 - 128);
 tempValue= temp/100;
 }

 // Return the value*/
//return tempValue;
// Compensate the temperature
/*	return BME280_RET_OK;
 }*/

